//+------------------------------------------------------------------+
//|                                                     Breakout.mq4 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "DemonFX"
#property link      "http://www.finsis.com"


//+------------------------------------------------------------------+
//| Initializing Variables                                           |
//| ----------------------                                           |
//| These values may be modified from outside                        |
//| the source via the expert program or indicator API.                               |
//+------------------------------------------------------------------+
extern int TakeProfit = 200;
extern double Lots = 0.1;
//extern int TrailingStop = 0; Not Used
extern int StopLoss = 10;
extern int Start = 15;
extern int Finish = 23;
extern int Bars2Check = 5; //How many bars back do you want to check for High and Low points? 
extern int Bars2CheckOffset = 1; //Offset to begin the Bar2Check for the High and Low points 
extern int BuyStop = 6; //How many points above breakout to buy
extern int SellStop = 6; //How many points below breakout to sell 
extern int max_movement = 40; //Maximun range between high and low breakout points


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
// Things to try:
               //Attach comments to each order to identify them
               //Print all Buy and Sell orders to the long and check the parameters
//----
   ObjectDelete("High");
   ObjectDelete("Low");
   
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  // Declare our internal variables for the BreakOut Indicator.
  double perClose = 0,newClose = 0,closehalf = 0,durration = 60;
  double perHigh = 0,perLow = 0,adx = 0;
  int cordLow = 0,cordHigh = 0;
  double aBuyStop = 0,aSellStop = 0;
  double Current = 0,halflots = 0,X=0;
  double chart = Period();
  int cnt = 0, bar = 0; 
  int DeleteThreashHold = Period()*10; //This ensures that every order is deleted and updated as new bars form.
  int err;


   if(!IsConnected())
   {
        Print("Dude, the connection to the server is broken! This advisor requires you to be connected in order to monito, place and modify your orders!");
        return(0);
   }

  if (((OrdersTotal() >= 1) && (DayOfWeek() == 1) && (Hour()>Start) && (Hour()<Finish)))
  {
      for(cnt=0;cnt<OrdersTotal();cnt++) 
      {
      
       OrderSelect(cnt, SELECT_BY_POS); //Select the current order
       if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) //this is a waiting order with a BuyStop of SellStop
       {
         if (CurTime()-OrderOpenTime()>DeleteThreashHold) //check to see how long it has been in the pool, if too long then clean up orders which have been in the order pool for longer than X time
         {
            OrderDelete(OrderTicket());
             err=GetLastError();
            Print("Deleted order number ", cnt, ". This completed with the following error code (0 = no error occured) : ", err);
            return(0);
   
         } 
       }
      }
  }
  
   if (bar < Bars) //if a new candle/bar has been created on the chart, then go and redraw the High and Low points for the last Bars2Check
  {
   cordHigh = Highest(NULL, 0, MODE_HIGH, Bars2Check, Bars2CheckOffset);
   cordLow =  Lowest(NULL, 0, MODE_LOW, Bars2Check, Bars2CheckOffset); 
   perHigh = High[cordHigh];
   perLow = Low[cordLow];
    
   //Update the global variables perHigh and perLow
   GlobalVariableSet(Period()+"perHigh",perHigh);
   GlobalVariableSet(Period()+"perLow",perLow);
   
   //Draw a line showing the Lowest Point in the last number of Bars2Check
   //Style properties: Color = Green, Line Style = Solid
   ObjectDelete("High");
   ObjectCreate("High", OBJ_HLINE, 0, CurTime(), perHigh, 0, 0, 0, 0);
   ObjectSet("High", OBJPROP_COLOR, Green);
   ObjectSet("High", OBJPROP_STYLE, STYLE_SOLID);

   //Draw a line showing the Lowest Point in the last number of Bars2Check
   //Style properties: Color = Yellow, Line Style = Solid   
   ObjectDelete("Low");
   ObjectCreate("Low", OBJ_HLINE, 0, CurTime(), perLow, 0, 0, 0, 0); 
   ObjectSet("Low", OBJPROP_COLOR, Yellow);
   ObjectSet("Low", OBJPROP_STYLE, STYLE_SOLID);   
   
   //Show our Highest and Lowest points on our chart with the Pips margin between the two
   Comment(High[cordHigh],"Last ",Bars2Check," Bars                                                                  High  ",perHigh,"                   Low   ",perLow,"              ",(perHigh-perLow)/Point," Pips");                   


   aBuyStop = perHigh+BuyStop*Point;
   aSellStop = perLow-SellStop*Point;
   double PrevDayHigh=iHigh(NULL,PERIOD_D1,1);
   double PrevDayLow=iLow(NULL,PERIOD_D1,1);
   bar=Bars;

  }

  perHigh =	GlobalVariableGet(Period()+"perHigh");
  perLow =	GlobalVariableGet(Period()+"perLow");  
  
  
  if (perHigh-perLow < max_movement*Point) //If the different between the Highest and Lowset points (in Pips) is less than max_movement (default 30 pips) then go and trade
  {
   if (((OrdersTotal() == 0) && (Hour()>Start) && (Hour()<Finish)))// there are no trades in any currency
   {
      OrderSend( Symbol(), OP_BUYSTOP, Lots, aBuyStop, 3, Low[2]-StopLoss*Point, aBuyStop+TakeProfit*Point, "OP_BUYSTOP sent. Order code is : 001.", 0, 0, Blue);
      Print("alert = 3 Placed an order in the buy stop pending position for under the ", Symbol(), " financial instrument. Order parameters are : Volume = ", Lots, " Price = ", aBuyStop, " Maximum Price Slippage = 3", " StopLoss = ", aBuyStop-StopLoss*Point, " TakeProfit = ", aBuyStop+TakeProfit*Point, ". The color of the opening arrow on the chart area will appear in BLUE.");
      
      return(0);   
   }

   if (((OrdersTotal() == 1) && (Hour()>Start) && (Hour()<Finish))) //only one open trade is in this currency and it's a buy stop 
   {
      OrderSelect(1, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() && OrderType() == OP_BUYSTOP) // This 1 open order is in this currency pairing and it's a buy stop pending position 
      {
         OrderSend( Symbol(), OP_SELLSTOP, Lots, aSellStop, 3, High[2]+StopLoss*Point, aSellStop-TakeProfit*Point, "OP_SELLSTOP sent. Order code is : 002.", 0, 0, Blue) ;            
         Print("alert = 4 Placed an order in the sell stop pending position for under the ", Symbol(), " financial instrument. Order parameters are : Volume = ", Lots, " Price = ", aSellStop, " Maximum Price Slippage = 3", " StopLoss = ", aSellStop+StopLoss*Point, " TakeProfit = ", aSellStop-TakeProfit*Point, ".The color of the opening arrow on the chart area will appear in BLUE.");
         return(0);
      }   
   }
   
   //Initialise our count of the number of open tickets under the current currency
   Current = 0;

   //Count the number of open tickets in this currency pairing
   for(cnt=0;cnt<OrdersTotal();cnt++) 
   {
    OrderSelect(cnt, SELECT_BY_POS); //Select the current order based on count
    if (OrderSymbol() == Symbol()) //Make sure this order is for the currency of the current chart
    {
      Current = Current + 1;
    }
   }
   //Re-initialise our counter   
   cnt = 0;
   
   if (((Current == 0) && (Hour()>Start) && (Hour()<Finish))) //if there are no open tickets for this currency pairing in the order pool
   {
      OrderSend( Symbol(), OP_BUYSTOP, Lots, aBuyStop, 3, Low[2]-StopLoss*Point, aBuyStop+TakeProfit*Point, "OP_BUYSTOP sent. Code order is : 003.", 0, 0, Blue) ;            
      Print("alert = 5 Placed an order in the buy stop pending position for under the ", Symbol(), " financial instrument. Order parameters are : Volume = ", Lots, " Price = ", aBuyStop, " Maximum Price Slippage = 3", " StopLoss = ", aBuyStop-StopLoss*Point, " TakeProfit = ", aBuyStop+TakeProfit*Point, ". The color of the opening arrow on the chart area will appear in BLUE.");
      return(0);      
   }
   
   if (((Current == 1) && (Hour()>Start) && (Hour()<Finish))) //if there is 1 open ticket for this currency pairing in the order pool
   {
     for(cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS);
      if (OrderSymbol() == Symbol() && OrderType( ) == OP_BUYSTOP) // if this order is in the current currency pairing and the order is in a buy stop pending position then SELL!!!
      {
         OrderSend( Symbol(), OP_SELLSTOP, Lots, aSellStop, 3, High[2]+StopLoss*Point, aSellStop-TakeProfit*Point, "OP_SELLSTOP sent. Code order is : 004.", 0, 0, Blue) ;            
         Print("alert = 6 Placed an order in the sell stop pending position for under the ", Symbol(), " financial instrument. Order parameters are : Volume = ", Lots, " Price = ", aSellStop, " Maximum Price Slippage = 3", " StopLoss = ", aSellStop+StopLoss*Point, " TakeProfit = ", aSellStop-TakeProfit*Point, ". The color of the opening arrow on the chart area will appear in BLUE.");
         return(0);      
      }
     } 
   }
  } //End Of: if (perHigh-perLow < max_movement*Point)
  
 
  return(0);
  }
//+------------------------------------------------------------------+